program togrf;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  finmaxsize=1048576;

var
  i,j,k:longint;
  fin,fout:file;
  indata:array[0..finmaxsize-1]of byte;
  pal:array[0..15,0..2]of byte; //g,r,b
  pic:array[0..399,0..639]of byte;
  mcpic:array[0..199,0..79]of byte;
  mcatr:array[0..199,0..79]of byte;
  outdata:array[0..65535]of byte;
  pichgt,picwid,mchgt,mcwid,paladdr,bmpaddr,totalwrite,inpointer:integer;
  b,col0,col1,oldcol0,oldcol1:byte;
  filename,savefilename:string;


function readin:byte;
//var
// b:byte;
begin
  readin:=indata[inpointer];
  inc(inpointer);
end;

procedure writeout(b:byte);
begin
  outdata[totalwrite]:=b;
  inc(totalwrite);
end;


begin
  { TODO -oUser -cConsole Main : Insert code here }
  if paramcount<1
  then filename:='doktorsk.bmp'
  else filename:=ParamStr(1);
  assign(fin,filename);
  reset(fin,1);
  if(filesize(fin)<=$76)then begin writeln('file too small');Halt(1);end;
  if(filesize(fin)>finmaxsize)then begin writeln('file too big');Halt(1);end;
  writeln('=========================== RetroX to GRF v0.1 ============================');
  writeln('convert TurboATM Multicolor, PrintScreen, crop, save as 8bit and give it me');
  writeln('input file=',filename);
  blockread(fin,indata,filesize(fin));
  close(fin);

//parse bmp
//8bit 16 color only
  bmpaddr:=indata[10] + indata[11]shl 8+ indata[12]shl 16 + indata[13]shl 24;
  paladdr:=$36;
  picwid:=indata[18] + indata[19]shl 8 + indata[20]shl 16 + indata[21]shl 24;
  pichgt:=indata[22] + indata[23]shl 8 + indata[24]shl 16 + indata[25]shl 24;
  if (pichgt>400)then begin writeln('hgt>400');Halt(1);end;
  if (picwid>640)then begin writeln('wid>640');Halt(1);end;
  if ((picwid mod 8)<>0)then begin writeln('(wid mod 8)<>0');Halt(1);end;
  mcwid:=picwid div 8;
  if ((pichgt mod 2)<>0)then begin writeln('(hgt mod 2)<>0');Halt(1);end;
  mchgt:=pichgt div 2;
  writeln(mchgt);
  if (indata[28]<>8)then begin writeln('not 8bit');Halt(1);end;
  if (indata[46]<>16)then begin writeln('not 16 color');Halt(1);end;
  inpointer:=paladdr;
  for i:=0 to 15 do
  begin
    pal[i,2]:=readin; //b
    pal[i,0]:=readin; //g
    pal[i,1]:=readin; //r
    b:=readin;
  end;
  inpointer:=bmpaddr;
  for j:=pichgt-1 downto 0 do
   for i:=0 to picwid-1 do
    pic[j,i]:=readin;

//bmp to mc (only even lines)
  for i:=0 to mcwid-1 do
   for j:=0 to mchgt-1 do
   begin
    //find col0, col1 (col0 <= col1)
    col0:=255;
    col1:=255;
    for k:=0 to 7 do
    begin
     b:=pic[j*2,i*8+k];
     if (col0=255) then col0:=b
     else if ((col0<>b)and(col1=255)) then col1:=b;
    end;
    if (col0>col1) then begin b:=col0;col0:=col1;col1:=b end;
    if (col1=col0) then
     if (col1=oldcol1) then col0:=oldcol0 //all filled with old ink
     else col1:=oldcol1; //all filled with old paper
    //find pix
    for k:=0 to 7 do
    begin
     b:=b shl 1;
     if(pic[j*2,i*8+k]<>col0)then inc(b);
    end;
    oldcol0:=col0;
    oldcol1:=col1;
    mcpic[j,i]:=b;
    mcatr[j,i]:=(col0 and 8)shl 4 + (col1 and 8)shl 3 + (col0 and 7)shl 3 + (col1 and 7);
   end;

//encode grf
  totalwrite:=0;
  for i:=0 to 15 do
   for j:=0 to 2 do
    writeout(ord('0')+(pal[i,j] div 64));
  for i:=48 to 127 do
   writeout(0);
  writeout((80-mcwid)div 2); //X
  writeout((200-mchgt)div 2); //Y
  writeout(mcwid);
  writeout(mchgt);
  for i:=0 to mcwid-1 do
   for j:=0 to mchgt-1 do
    writeout(mcpic[j,i]);
  for i:=0 to mcwid-1 do
  begin
   col0:=0; //start new run length
   for j:=0 to mchgt-1 do
   begin
    if (mcatr[j,i]=oldcol0)
    then inc(col0) //count
    else begin
     if (col0<>0)
     then begin
      writeout(col0); //count
      writeout(oldcol0);
     end;
     oldcol0:=mcatr[j,i];
     col0:=1; //count
    end;
   end; //byte in column
   writeout(col0); //count
   writeout(oldcol0);
  end; //column

  savefilename:=filename;
  j:=0;
  for i:=1 to length(savefilename) do
   if savefilename[i]='.' then j:=i;
  if (j>0) and (j>length(savefilename)-4) then delete(savefilename,j,4);
  savefilename:=savefilename+'.grf';

  assign(fout,savefilename);
  rewrite(fout,1);
  blockwrite(fout,outdata,totalwrite);
  close(fout);
  writeln('total bytes=',totalwrite);
  if (totalwrite>$9000)
  then writeln('file too long!');
end.
